from fastapi import APIRouter, Query

from app.controllers.algorithms.graph_coloring import get_graph_coloring
from app.models.domain.algorithms import GraphColoringRequest, GraphColoringResponse

router = APIRouter()


@router.post('/graph-coloring', response_model=GraphColoringResponse)
async def get_graph_coloring_result(graph_info: GraphColoringRequest):
    black, white, random = await get_graph_coloring(
        graph_info.vertexes,
        graph_info.edges
    )

    return {
        'black': black,
        'white': white,
        'random': random
    }
